# Build with debug info rpm
%global with_debug 0

%if 0%{?with_debug} > 0
%global _dwz_low_mem_die_limit 0
%else
%global debug_package %{nil}
%endif

%global git_commit c0f68f7e52684776c878a23b460a78def382af57
%global git_shortcommit  %(c=%{git_commit}; echo ${c:0:7})
%global checksum 8aca6028fa489fa4a8c59f5a08aa67a3

Name:           servicemesh-prometheus
Version:        2.7.2
Release:        36%{?dist}
Summary:        An open-source systems monitoring and alerting toolkit 
License:        ASL 2.0
URL:            https://prometheus.io/

BuildRequires:  servicemesh-prometheus-promu = 0.2.0
BuildRequires:  golang >= 1.11

Source0:        servicemesh-prometheus.%{checksum}.tar.gz
Patch0:         0001-MAISTRA-1463-Update-gopkg.in-yaml.v2-to-v2.3.0.patch

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 aarch64 %{arm}}

%global binary_name prometheus

%description
Prometheus is an open-source systems monitoring and alerting toolkit.

%package prometheus
Summary:  A monitoring and alerting toolkit

%description prometheus
Package containing prometheus files.

%prep

rm -rf PROMETHEUS
mkdir -p PROMETHEUS/src/github.com/prometheus/prometheus
tar zxf %{SOURCE0} -C PROMETHEUS/src/github.com/prometheus/prometheus --strip=1

pushd PROMETHEUS/src/github.com/prometheus/prometheus
%patch0 -p1
popd

%build
cd PROMETHEUS
export GOPATH=$(pwd):%{gopath}
cd src/github.com/prometheus/prometheus

PROMU=$(which promu) make -e build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{binary_name}/console_libraries/
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{binary_name}/consoles/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/%{binary_name}/

binaries=(prometheus promtool)
cd PROMETHEUS/src/github.com/prometheus/prometheus
%if 0%{?with_debug} > 0
  for i in "${binaries[@]}"; do
        cp -pav $i $RPM_BUILD_ROOT%{_bindir}/
   done
%else
    mkdir stripped
    touch keep_symbols
    for i in "${binaries[@]}"; do
       echo "Dumping dynamic symbols for ${i}"
        nm -D $i --format=posix --defined-only \
  | awk '{ print $1 }' | sort > dynsyms

        echo "Dumping function symbols for ${i}"
       nm $i --format=posix --defined-only \
  | awk '{ if ($2 == "T" || $2 == "t" || $2 == "D") print $1 }' \
  | sort > funcsyms

        echo "Grabbing other function symbols from ${i}"
        comm -13 dynsyms funcsyms > keep_symbols

        COMPRESSED_NAME="${i}_debuginfo"
        if [ -s keep_symbols ]; then
          echo "remove unnecessary debug info from ${i}"
          objcopy -S --remove-section .gdb_index --remove-section .comment \
  --keep-symbols=keep_symbols "${i}" "${COMPRESSED_NAME}"
        fi

        echo "stripping: ${i}"
        strip -o "stripped/${i}" -s $i

        if [ -f ${COMPRESSED_NAME} ]; then
          echo "compress debugdata for ${i} into ${COMPRESSED_NAME}.xz"
          xz "${COMPRESSED_NAME}"

          echo "inject compressed data into .gnu_debugdata for ${i}"
          objcopy --add-section ".gnu_debugdata=${COMPRESSED_NAME}.xz" "stripped/${i}"
        fi

        cp -pav "stripped/${i}" "${RPM_BUILD_ROOT}%{_bindir}/"
    done
%endif

cp -a console_libraries/ $RPM_BUILD_ROOT%{_datadir}/%{binary_name}
ln -sf %{_datadir}/%{binary_name}/console_libraries/ $RPM_BUILD_ROOT%{_sysconfdir}/%{binary_name}/
cp -a consoles/ $RPM_BUILD_ROOT%{_datadir}/%{binary_name}/
ln -sf %{_datadir}/%{binary_name}/consoles/ $RPM_BUILD_ROOT%{_sysconfdir}/%{binary_name}/
cp -a documentation/examples/prometheus.yml $RPM_BUILD_ROOT%{_sysconfdir}/%{binary_name}/%{binary_name}.yml

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files
%license PROMETHEUS/src/github.com/prometheus/prometheus/LICENSE
%doc     PROMETHEUS/src/github.com/prometheus/prometheus/README.md
%{_bindir}/prometheus
%{_bindir}/promtool
%{_datadir}/%{binary_name}/console_libraries/
%{_sysconfdir}/%{binary_name}/console_libraries
%{_datadir}/%{binary_name}/consoles/
%{_sysconfdir}/%{binary_name}/consoles
%config(noreplace) %{_sysconfdir}/%{binary_name}/%{binary_name}.yml

%changelog
* Mon Jun 29 2020 Product Release - 2.7.2-36
- Update to latest release

* Thu Mar 19 2020 Product Release - 2.7.2-35
- Update to latest release

* Mon Mar 02 2020 Product Release - 2.7.2-34
- Update to latest release

* Sat Feb 22 2020 Product Release - 2.7.2-33
- Update to latest release

* Thu Feb 20 2020 Product Release - 2.7.2-32
- Update to latest release

* Fri Feb 07 2020 Product Release - 2.7.2-31
- Update to latest release

* Wed Jan 29 2020 Product Release - 2.7.2-30
- Update to latest release

* Wed Jan 22 2020 Product Release - 2.7.2-29
- Update to latest release

* Wed Jan 22 2020 Product Release - 2.7.2-28
- Update to latest release

* Tue Jan 07 2020 Product Release - 2.7.2-27
- Update to latest release

* Thu Dec 05 2019 Product Release - 2.7.2-26
- Update to latest release

* Sat Oct 26 2019 Product Release - 2.7.2-25
- Update to latest release

* Fri Oct 25 2019 Product Release - 2.7.2-24
- Update to latest release

* Fri Oct 25 2019 Product Release - 2.7.2-23
- Update to latest release

* Mon Oct 07 2019 Product Release - 2.7.2-22
- Update to latest release

* Sat Oct 05 2019 Product Release - 2.7.2-21
- Update to latest release

* Sat Oct 05 2019 Product Release - 2.7.2-20
- Update to latest release

* Fri Oct 04 2019 Product Release - 2.7.2-19
- Update to latest release

* Fri Oct 04 2019 Product Release - 2.7.2-18
- Update to latest release

* Fri Oct 04 2019 Product Release - 2.7.2-17
- Update to latest release

* Fri Oct 04 2019 Product Release - 2.7.2-16
- Update to latest release

* Fri Oct 04 2019 Product Release - 2.7.2-15
- Update to latest release

* Sat Aug 24 2019 Product Release - 2.7.2-14
- Update to latest release

* Fri Aug 23 2019 Product Release - 2.7.2-13
- Update to latest release

* Fri Aug 23 2019 Product Release - 2.7.2-12
- Update to latest release

* Fri Aug 16 2019 Product Release - 2.7.2-11
- Update to latest release

* Fri Aug 16 2019 Product Release - 2.7.2-2
- Update to latest release

* Fri Aug 16 2019 Product Release - 2.7.2-1
- Update to latest release

* Fri Aug 16 2019 Product Release - 2.7.2-10
- Update to latest release

* Fri Aug 16 2019 Product Release - 2.7.2-9
- Update to latest release

* Thu Aug 15 2019 Product Release - 2.7.2-8
- Update to latest release

* Thu Aug 15 2019 Product Release - 2.7.2-7
- Update to latest release

* Thu Aug 15 2019 Product Release - 2.7.2-6
- Update to latest release

* Tue Jul 09 2019 Daily Build - 2.7.2-5
- Update to latest release

* Tue Jul 09 2019 Daily Build - 2.7.2-4
- Update to latest release

* Tue Jul 09 2019 Daily Build - 2.7.2-3
- Update to latest release

* Tue Jul 09 2019 Daily Build - 2.7.2-2
- Update to latest release

* Tue Jun 25 2019 Dmitri Dolguikh <ddolguik@redhat.com> - 2.7.2-1
- First build
